/* ---------------------------------------------------------
This is a sample check for the GazIntech transaction-
notification dispatcher.  It assumes that the dispatcher is
invoked with the prefix 'GT_TN', although you may use any
other prefix.  The check requires that the name of a
business partner not exceed five characters.

In this wise you can extract individual tests from
SBO_SP_TransactionNotification into separate procedures,
which the dispatcher will invoke automatically.
--------------------------------------------------------- */

DROP PROCEDURE "GT_TN_BP_PreventLongNames";
CREATE PROCEDURE "GT_TN_BP_PreventLongNames"
(	IN  objType  NVARCHAR ( 20),
	IN  objKey   NVARCHAR (255),
	IN  action   NVARCHAR (  1),
	OUT error    NVARCHAR (200)
)
AS cardName  NVARCHAR(64);
   maxLen    INT;
BEGIN SEQUENTIAL EXECUTION
	maxLen := 5;
	IF :objType <> '2' THEN RETURN; END IF;
	
	IF :action <> 'A' AND :action <> 'U' THEN RETURN; END IF;
		
	SELECT "CardName" INTO cardName FROM OCRD
	WHERE "CardCode" = :objKey;
	
	IF LENGTH( :cardName ) <= :maxLen THEN RETURN; END IF;
	
	error := N'Business partner name shall not be longer than ' ||
	         CAST(:maxLen AS VARCHAR(4)) || ' characters.';
END;
