/* ---------------------------------------------------------
The sample code below shows how to install the GazIntech
transaction-notification dispatcher to a B1 company
database.  Simply invoke GT_TranDispatcher from the desired
call-back procedure, which may be either

  a.  SBO_SP_TransactionNotification or
  b.  SBO_SP_PostTransactionNotice,

with a special prefix.  Our convention, for instance, is to
use 'GT_TN' for the former and 'GT_PTN' for the latter, so
that the procedure names start with 'GT_TN_' and 'GT_PTN_'.
--------------------------------------------------------- */

DROP   PROCEDURE SBO_SP_TransactionNotification;
CREATE PROCEDURE SBO_SP_TransactionNotification
(
	in object_type nvarchar(20),  -- SBO Object Type
	in transaction_type nchar(1), -- [A]dd, [U]pdate, [D]elete, [C]ancel, C[L]ose
	in num_of_cols_in_key int,
	in list_of_key_cols_tab_del nvarchar(255),
	in list_of_cols_val_tab_del nvarchar(255)
)
LANGUAGE SQLSCRIPT
AS	error  int;
	error_message nvarchar (200);
BEGIN SEQUENTIAL EXECUTION

	error := 0;
	error_message := N'Ok';
	
	CALL GT_TranDispatcher
	(	'GT_TN', :object_type, :list_of_cols_val_tab_del,
		:transaction_type, error, error_message
	);
	
	IF :error = 0 THEN
		/* Move existing checks here until you convert them to GT_TN_* procedures */
	END IF;
	
	SELECT :error, :error_message FROM DUMMY;
END;
