/* ---------------------------------------------------------
This is a sample check for the GazIntech transaction-
notification dispatcher.  It assumes that the dispatcher is
invoked with the prefix 'GT_TN', although you may use any
other prefix.  The check requires that the name of a
business partner not exceed five characters.

In this wise you can extract individual tests from
SBO_SP_TransactionNotification into separate procedures,
which the dispatcher will invoke automatically.
--------------------------------------------------------- */

IF Object_ID(N'GT_TN_BP_PreventLongNames') IS NOT NULL
	DROP PROCEDURE GT_TN_BP_PreventLongNames
GO

CREATE PROCEDURE GT_TN_BP_PreventLongNames
(	@type    NVARCHAR(20), 				
	@key     NVARCHAR(255),
	@action  NVARCHAR(1),
	@errText NVARCHAR(200)   OUTPUT
)
AS
DECLARE @cardName AS varchar(10)
DECLARE @maxLen   AS int

SET @maxLen = 5
BEGIN
	IF @type <> '2' RETURN
	IF @action NOT IN ('A', 'U') RETURN

	SELECT @cardName = COALESCE( CardName ,' ')
	FROM OCRD WHERE CardCode = @key

	IF LEN( @cardName ) <= @maxLen RETURN

	SET @errText = N'Business partner name shall not be longer than ' +
	               CAST(@maxLen AS varchar(4)) + ' characters.'
END
